From 6c5637c5d3ffb1fecfd93cb2fcd56e9c102b915f Mon Sep 17 00:00:00 2001
From: Alan <alan@boum.org>
Date: Sat, 20 Aug 2016 11:02:20 +0000
Subject: [PATCH] Use xsetroot to set cursor

This will be quicker and use less memory than the python solution.
It would however need to be reverted or rewritten when we'll switch
from X11 to wayland.
---
 lib/set-cursor.py                    | 19 -------------------
 setup.py                             |  3 +--
 tails-greeter                        |  5 ++++-
 tails-greeter-session-helper.desktop |  2 +-
 4 files changed, 6 insertions(+), 23 deletions(-)
 delete mode 100755 lib/set-cursor.py

diff --git a/lib/set-cursor.py b/lib/set-cursor.py
deleted file mode 100755
index 09a7bd4..0000000
--- a/lib/set-cursor.py
+++ /dev/null
@@ -1,19 +0,0 @@
-#!/usr/bin/python3
-import sys
-
-from gi.repository import Gdk
-from gi.repository import GLib
-from gi.repository import Gtk
-
-print(sys.argv)
-if len(sys.argv) > 1 and sys.argv[1] == "watch":
-    cursor = Gdk.CursorType.WATCH
-else:
-    cursor = Gdk.CursorType.LEFT_PTR
-
-def reset_cursor():
-    Gdk.get_default_root_window().set_cursor(Gdk.Cursor.new(cursor))
-    Gtk.main_quit()
-
-GLib.idle_add(reset_cursor)
-Gtk.main()
diff --git a/setup.py b/setup.py
index 58a353e..c5b1592 100755
--- a/setup.py
+++ b/setup.py
@@ -57,8 +57,7 @@ setup(
         data_files       = [
             ( SDIR, ['data/greeter.ui', 'data/greeter.css',
                      'data/tails-logging.conf', 'data/no-password-lecture.txt',
-                     'data/default_langcodes', 'lib/set-cursor.py',
-                     'lib/tails-greeter.py'] ),
+                     'data/default_langcodes', 'lib/tails-greeter.py'] ),
             ( 'share/applications/', [ 'data/tails-greeter.desktop' ] ),
             ( 'share/gnome-session/sessions/', [ 'data/gdm-tails.session' ] ),
             ( 'share/gnome-shell/modes/', [ 'data/gdm-tails.json' ] ),
diff --git a/tails-greeter b/tails-greeter
index 7637a04..5f7cfb0 100755
--- a/tails-greeter
+++ b/tails-greeter
@@ -1,5 +1,8 @@
 #!/bin/bash
 cd /usr/share/tails-greeter/
 export LANG="en_US.UTF-8"
-/usr/share/tails-greeter/set-cursor.py watch
+# Set watch root cursor. The cursor be reset to the arrow by the greeter
+# when it is ready. This will fail when we'll switch to wayland, see commit
+# 03aff69 for a python implementation.
+xsetroot -cursor_name watch
 /usr/bin/python3 ./tails-greeter.py
diff --git a/tails-greeter-session-helper.desktop b/tails-greeter-session-helper.desktop
index 67aa923..8566173 100644
--- a/tails-greeter-session-helper.desktop
+++ b/tails-greeter-session-helper.desktop
@@ -1,7 +1,7 @@
 [Desktop Entry]
 Name=Tails-greeter User Session Helper
 Comment=This helper will reset busy cursor set by tails-greeter
-Exec=/usr/share/tails-greeter/set-cursor.py
+Exec=xsetroot -cursor_name arrow
 StartupNotify=false
 Type=Application
 NoDisplay=true
-- 
2.1.4

